import { formChainEntity } from 'chain_entity/functions.js';

export const events = {
	"raigen:cavalrot_set": function(e){
		formChainEntity(e, 7 + Math.round(Math.random() * 5), true, false);
	},
	"raigen:freak_set": function(e){
		formChainEntity(e, 4, false, true);
	},
	"raigen:skull_train_set": function(e){
		formChainEntity(e, 10 + Math.round(Math.random() * 5), false, false);
	},
	"raigen:chain_entity_follow": function(e){
		let id = e.getProperty('raigen:unique_chain_id');
		let scale = e.getComponent('scale') != undefined ? e.getComponent('scale').value : 0;
		let link = e.getProperty('raigen:chain_index');
		let com = e.runCommand(`testfor @e[r=10, has_property={raigen:unique_chain_id=${id}, raigen:chain_index=${link - 1}}]`);
		if(com.successCount == 1){
			e.runCommand(`tp @s ^ ^ ^0.5 facing @e[rm=${1.125 + (scale / 3.5)}, r=10, has_property={raigen:unique_chain_id=${id}, raigen:chain_index=${link - 1}}]`);
		}
		else{
			e.runCommand(`kill @e[has_property={raigen:unique_chain_id=${id}}]`);
		}
	},
	"raigen:chain_entity_death": function(e){
		let id = e.getProperty('raigen:unique_chain_id');
		e.runCommand(`kill @e[has_property={raigen:unique_chain_id=${id}}]`);
	}
}