export function formChainEntity(entity, count, hasTail, sequential){
	let randomProperty = Math.floor(Math.random() * 1000);
	entity.setProperty('raigen:unique_chain_id', randomProperty);
	entity.setProperty('raigen:chain_index', 0);
	for(var i = 1; i < count + 1; i++){
		let segment = entity.dimension.spawnEntity(`${entity.typeId}<raigen:event_segment>`, entity.location);
		segment.setProperty('raigen:unique_chain_id', randomProperty);
		segment.setProperty('raigen:chain_index', i);
		if(hasTail && i == count){
			segment.triggerEvent('raigen:event_tail');
		}
		if(sequential){
			segment.triggerEvent(`raigen:event_part_${i}`);
		}
	}
}