import { world, system } from '@minecraft/server';
import { useCharredBoneMeal } from 'true_carnage/functions.js';

world.beforeEvents.worldInitialize.subscribe(e =>{
	e.itemComponentRegistry.registerCustomComponent('raigen:on_use_on', {
		onUseOn(i){
			let { blockFace, block, itemStack, source } = i;
			useCharredBoneMeal(source, itemStack, block);
		}
	});
});